EE3270 Hwk2 HSPICE file for worstcase analysis of voltage amps

* bjt circuits

VCC      VCC         0          DC        12V
VACbjt   acbjt       0          AC        20mV     SIN(0mV 20mV 1kHz)
RSbjt    acbjt       inbjt      1k

Cce1     inbjt       ince1      10mF
XCE1     ince1       outbjt     VCC       0        CEnpn
+        R2=50k      R1=10k     RE=1k     RC=1.8k  MM=1


* mos circuits

VDD      VDD         0          DC       12V
VACmos   acmos       0          AC       20mV      SIN(0mV 20mV 1kHz)
RSmos    acmos       inmos      1k

Ccs1     inmos       incs1      10mF
XCS1     incs1       outmos     VDD      0         CSnmos
+        R2=40MEG    R1=10MEG   RS=100k  RD=800k   MM=1



* The analysis and output control section

* transient and fourier large signal analysis

* fourier analysis

.four 1kHz V(outbjt) V(outmos)

* stage by stage outputs 

.probe tran v(acbjt) V(inbjt) V(outbjt) 
.probe tran i(XCE1.XQ1.VIB) i(XCE1.XQ1.VIC)

.probe tran v(acmos) V(inmos) V(outmos)
.probe tran i(XCS1.XM1.VIG) i(XCS1.XM1.VID)

* ac small signal analysis

.measure ac Avoo FIND v(outbjt) AT=1kHz
.measure ac Avio FIND v(acbjt) AT=1kHz
.measure ac Avo  PARAM='Avoo/Avio'
.measure ac Avoom FIND v(outmos) AT=1kHz
.measure ac Aviom FIND v(acmos) AT=1kHz
.measure ac Avom  PARAM='Avoom/Aviom'
.measure ac vodb FIND vdb(outbjt) AT=1kHz
.measure ac f3odB WHEN vdb(outbjt)='vodb-3' CROSS=1
.measure ac vodbm FIND vdb(outmos) AT=1kHz
.measure ac f3odBm WHEN vdb(outmos)='vodbm-3' CROSS=1

** Analysis setup **

.options post=2 measout badchr nopage co=160 
.options opts cptime=1e7 limtim=60 probe
.options defl=1.0um  defw=4.0um

.op
.tran 10us 5ms SWEEP DATA=worstcase
.ac DEC 10 1k 1000MEG SWEEP DATA=worstcase

* the subcircuits DO NOT Change

.subckt CEnpn vin vout VCC VEE
+ R2=100k R1=10k RE=1k RC=4k MM=1
Viin  vin  VB   DC    0V
R2    VCC  VB   R2
R1    VB   VEE  R1
XQ1   VC   VB   VE    XNPNmodel M=MM
RC    VCC  VC   RC
Viout vout VC   DC    0V
RE    VE   VEE  RE
CE    VE   VEE 10mF
.measure ac AvdB FIND par('vdb(vout)-vdb(vin)') AT=1Hz
.measure ac f3dB WHEN par('vdb(vout)-vdb(vin)')='AvdB-3' CROSS=1
.measure ac vino FIND v(vin) AT=1Hz
.measure ac iino FIND i(viin) AT=1Hz
.measure ac Rin  PARAM='vino/iino'
.measure ac vlo FIND v(vout) AT=1Hz
.measure ac ilo FIND i(viout) AT=1Hz
.measure ac Rload  PARAM='vlo/ilo'
.measure ac Avo FIND v(vout) AT=1Hz
.measure ac Avio FIND v(vin) AT=1Hz
.measure ac Av  PARAM='Avo/Avio'
.ends CEnpn

.subckt CEpnp vin vout VEE VCC
+ R2=100k R1=10k RE=1k RC=4k MM=1
Viin  vin  VB   DC    0V
R2    VCC  VB   R2
R1    VB   VEE  R1
XQ1   VC   VB   VE    XPNPmodel M=MM
RC    VCC  VC   RC
Viout vout VC   DC    0V
RE    VE   VEE  RE
CE    VE   VEE 10mF
.measure ac AvdB FIND par('vdb(vout)-vdb(vin)') AT=1Hz
.measure ac f3dB WHEN par('vdb(vout)-vdb(vin)')='AvdB-3' CROSS=1
.measure ac vino FIND v(vin) AT=1Hz
.measure ac iino FIND i(viin) AT=1Hz
.measure ac Rin  PARAM='vino/iino'
.measure ac vlo FIND v(vout) AT=1Hz
.measure ac ilo FIND i(viout) AT=1Hz
.measure ac Rload  PARAM='vlo/ilo'
.measure ac Avo FIND v(vout) AT=1Hz
.measure ac Avio FIND v(vin) AT=1Hz
.measure ac Av  PARAM='Avo/Avio'
.ends CEpnp

.subckt dCEnpn vin1 vin2 vout1 vout2 VCC VEE
+ R=11.3k R2=20k R1=20k RC=4k MM=1
Viin1 vin1 VB1  DC    0V
R21   VCC  VB1  R2
R11   VB1  VEE  R1
XQ1   VC1  VB1  VE    XNPNmodel M=MM
RC1   VCC  VC1  RC
Viin2 vin2 VB2  DC    0V
R22   VCC  VB2  R2
R12   VB2  VEE  R1
XQ2   VC2  VB2  VE    XNPNmodel M=MM
RC2   VCC  VC2  RC
Evin  vin  0  vin1 vin2 1
Rvin vin 0 1T
Evout vout 0 vout1 vout2 1
Rvout vout 0 1T
Viout1 vout1 VC1   DC    0V
Viout2 vout2 VC2   DC    0V
XQE   VE   vbias VEE  XNPNmodel M='2*MM'
XQb   vbias vbias VEE XNPNmodel M=1
R     VCC vbias R
.measure ac Av1dB FIND par('vdb(vout1)-vdb(vin)') AT=1Hz
.measure ac Av2dB FIND par('vdb(vout2)-vdb(vin)') AT=1Hz
.measure ac AvdB FIND par('vdb(vout)-vdb(vin)') AT=1Hz
.measure ac f3dB1 WHEN par('vdb(vout1)-vdb(vin)')='Av1dB-3' CROSS=1
.measure ac f3dB2  WHEN par('vdb(vout2)-vdb(vin)')='Av2dB-3' CROSS=1
.measure ac f3dB WHEN par('vdb(vout)-vdb(vin)')='AvdB-3' CROSS=1
.measure ac vin1o FIND v(vin1) AT=1Hz
.measure ac iin1o FIND i(viin1) AT=1Hz
.measure ac Rin1  PARAM='vin1o/iin1o'
.measure ac vl1o FIND v(vout1) AT=1Hz
.measure ac il1o FIND i(viout1) AT=1Hz
.measure ac Rload1  PARAM='vl1o/il1o'
.measure ac voo1 FIND v(vout1) AT=1Hz
.measure ac vio1 FIND v(vin1) AT=1Hz
.measure ac Av1  PARAM='voo1/vio1'
.measure ac vin2o FIND v(vin2) AT=1Hz
.measure ac iin2o FIND i(viin2) AT=1Hz
.measure ac Rin2  PARAM='vin2o/iin2o'
.measure ac vl2o FIND v(vout2) AT=1Hz
.measure ac il2o FIND i(viout2) AT=1Hz
.measure ac Rload2  PARAM='vl2o/il2o'
.measure ac voo2 FIND v(vout2) AT=1Hz
.measure ac vio2 FIND v(vin2) AT=1Hz
.measure ac Av2  PARAM='voo2/vio2'
.measure ac vin FIND v(vin) AT=1Hz
.measure ac iin FIND i(viin1) AT=1Hz
.measure ac Rin PARAM='vin/iin'
.measure ac vlo FIND v(vout) AT=1Hz
.measure ac ilo FIND i(viout1) AT=1Hz
.measure ac Rload PARAM='vlo/ilo'
.measure ac voo FIND v(vout) AT=1Hz
.measure ac vio FIND v(vin) AT=1Hz
.measure ac Avd1  PARAM='voo1/vio'
.measure ac Avd2  PARAM='voo2/vio'
.measure ac Av  PARAM='voo/vio'
.ends dCEnpn

.subckt dCEpnp vin1 vin2 vout1 vout2 VCC VEE
+ R=11.3k R2=20k R1=20k RC=4k MM=1
Viin1 vin1 VB1  DC    0V
R21   VEE  VB1  R2
R11   VB1  VCC  R1
XQ1   VC1  VB1  VE    XPNPmodel M=MM
RC1   VEE  VC1  RC
Viin2 vin2 VB2  DC    0V
R22   VEE  VB2  R2
R12   VB2  VCC  R1
XQ2   VC2  VB2  VE    XPNPmodel M=MM
RC2   VEE  VC2  RC
Evin  vin  0  vin1 vin2 1
Rvin vin 0 1T
Evout vout 0 vout1 vout2 1
Rvout vout 0 1T
Viout1 vout1 VC1   DC    0V
Viout2 vout2 VC2   DC    0V
XQE   VE   vbias VCC  XPNPmodel M='2*MM'
XQb   vbias vbias VCC XPNPmodel M=1
R     VEE vbias R
.measure ac Av1dB FIND par('vdb(vout1)-vdb(vin)') AT=1Hz
.measure ac Av2dB FIND par('vdb(vout2)-vdb(vin)') AT=1Hz
.measure ac AvdB FIND par('vdb(vout)-vdb(vin)') AT=1Hz
.measure ac f3dB1 WHEN par('vdb(vout1)-vdb(vin)')='Av1dB-3' CROSS=1
.measure ac f3dB2  WHEN par('vdb(vout2)-vdb(vin)')='Av2dB-3' CROSS=1
.measure ac f3dB WHEN par('vdb(vout)-vdb(vin)')='AvdB-3' CROSS=1
.measure ac vin1o FIND v(vin1) AT=1Hz
.measure ac iin1o FIND i(viin1) AT=1Hz
.measure ac Rin1  PARAM='vin1o/iin1o'
.measure ac vl1o FIND v(vout1) AT=1Hz
.measure ac il1o FIND i(viout1) AT=1Hz
.measure ac Rload1  PARAM='vl1o/il1o'
.measure ac voo1 FIND v(vout1) AT=1Hz
.measure ac vio1 FIND v(vin1) AT=1Hz
.measure ac Av1  PARAM='voo1/vio1'
.measure ac vin2o FIND v(vin2) AT=1Hz
.measure ac iin2o FIND i(viin2) AT=1Hz
.measure ac Rin2  PARAM='vin2o/iin2o'
.measure ac vl2o FIND v(vout2) AT=1Hz
.measure ac il2o FIND i(viout2) AT=1Hz
.measure ac Rload2  PARAM='vl2o/il2o'
.measure ac voo2 FIND v(vout2) AT=1Hz
.measure ac vio2 FIND v(vin2) AT=1Hz
.measure ac Av2  PARAM='voo2/vio2'
.measure ac vin FIND v(vin) AT=1Hz
.measure ac iin FIND i(viin1) AT=1Hz
.measure ac Rin PARAM='vin/iin'
.measure ac vlo FIND v(vout) AT=1Hz
.measure ac ilo FIND i(viout1) AT=1Hz
.measure ac Rload PARAM='vlo/ilo'
.measure ac voo FIND v(vout) AT=1Hz
.measure ac vio FIND v(vin) AT=1Hz
.measure ac Avd1  PARAM='voo1/vio'
.measure ac Avd2  PARAM='voo2/vio'
.measure ac Av  PARAM='voo/vio'
.ends dCEpnp

.subckt CEwREnpn vin vout VCC VEE
+ R2=100k R1=10k RE=1k RC=4k MM=1
Viin  vin  VB   DC    0V
R2    VCC  VB   R2
R1    VB   VEE  R1
XQ1   VC   VB   VE    XNPNmodel M=MM
RC    VCC  VC   RC
Viout vout VC   DC    0V
RE    VE   VEE  RE
.measure ac AvdB FIND par('vdb(vout)-vdb(vin)') AT=1Hz
.measure ac f3dB WHEN par('vdb(vout)-vdb(vin)')='AvdB-3' CROSS=1
.measure ac vino FIND v(vin) AT=1Hz
.measure ac iino FIND i(viin) AT=1Hz
.measure ac Rin  PARAM='vino/iino'
.measure ac vlo FIND v(vout) AT=1Hz
.measure ac ilo FIND i(viout) AT=1Hz
.measure ac Rload  PARAM='vlo/ilo'
.measure ac Avo FIND v(vout) AT=1Hz
.measure ac Avio FIND v(vin) AT=1Hz
.measure ac Av  PARAM='Avo/Avio'
.ends CEwREnpn

.subckt dCEwREnpn vin1 vin2 vout1 vout2 VCC VEE
+ R=11.3k R2=20k R1=20k RC=4k RE=1k MM=1
Viin1 vin1 VB1  DC    0V
R21   VCC  VB1  R2
R11   VB1  VEE  R1
XQ1   VC1  VB1  VE1   XNPNmodel M=MM
RE1   VE1  VE   RE
RC1   VCC  VC1  RC
Viin2 vin2 VB2  DC    0V
R22   VCC  VB2  R2
R12   VB2  VEE  R1
XQ2   VC2  VB2  VE2   XNPNmodel M=MM
RE2   VE2  VE   RE
RC2   VCC  VC2  RC
Viout1 vout1 VC1   DC    0V
Viout2 vout2 VC2   DC    0V
XQE   VE   vbias VEE  XNPNmodel M='2*MM'
XQb   vbias vbias VEE XNPNmodel M=1
R     VCC vbias R
Evin  vin  0  vin1 vin2 1
Rvin vin 0 1T
Evout vout 0 vout1 vout2 1
Rvout vout 0 1T
.measure ac Av1dB FIND par('vdb(vout1)-vdb(vin)') AT=1Hz
.measure ac Av2dB FIND par('vdb(vout2)-vdb(vin)') AT=1Hz
.measure ac AvdB FIND par('vdb(vout)-vdb(vin)') AT=1Hz
.measure ac f3dB1 WHEN par('vdb(vout1)-vdb(vin)')='Av1dB-3' CROSS=1
.measure ac f3dB2  WHEN par('vdb(vout2)-vdb(vin)')='Av2dB-3' CROSS=1
.measure ac f3dB WHEN par('vdb(vout)-vdb(vin)')='AvdB-3' CROSS=1
.measure ac vin1o FIND v(vin1) AT=1Hz
.measure ac iin1o FIND i(viin1) AT=1Hz
.measure ac Rin1  PARAM='vin1o/iin1o'
.measure ac vl1o FIND v(vout1) AT=1Hz
.measure ac il1o FIND i(viout1) AT=1Hz
.measure ac Rload1  PARAM='vl1o/il1o'
.measure ac voo1 FIND v(vout1) AT=1Hz
.measure ac vio1 FIND v(vin1) AT=1Hz
.measure ac Av1  PARAM='voo1/vio1'
.measure ac vin2o FIND v(vin2) AT=1Hz
.measure ac iin2o FIND i(viin2) AT=1Hz
.measure ac Rin2  PARAM='vin2o/iin2o'
.measure ac vl2o FIND v(vout2) AT=1Hz
.measure ac il2o FIND i(viout2) AT=1Hz
.measure ac Rload2  PARAM='vl2o/il2o'
.measure ac voo2 FIND v(vout2) AT=1Hz
.measure ac vio2 FIND v(vin2) AT=1Hz
.measure ac Av2  PARAM='voo2/vio2'
.measure ac vin FIND v(vin) AT=1Hz
.measure ac iin FIND i(viin1) AT=1Hz
.measure ac Rin PARAM='vin/iin'
.measure ac vlo FIND v(vout) AT=1Hz
.measure ac ilo FIND i(viout1) AT=1Hz
.measure ac Rload PARAM='vlo/ilo'
.measure ac voo FIND v(vout) AT=1Hz
.measure ac vio FIND v(vin) AT=1Hz
.measure ac Avd1  PARAM='voo1/vio'
.measure ac Avd2  PARAM='voo2/vio'
.measure ac Av  PARAM='voo/vio'
.ends dCEwREnpn

.subckt CCnpn vin vout VCC VEE
+ R2=100k R1=10k RE=1k MM=1
Viin  vin  VB   DC    0V
R2    VCC  VB   R2
R1    VB   VEE  R1
XQ1   VCC  VB   VE    XNPNmodel M=MM
Viout vout VE   DC    0V
RE    VE   VEE  RE
.measure ac AvdB FIND par('vdb(vout)-vdb(vin)') AT=1Hz
.measure ac f3dB WHEN par('vdb(vout)-vdb(vin)')='AvdB-3' CROSS=1
.measure ac vino FIND v(vin) AT=1Hz
.measure ac iino FIND i(viin) AT=1Hz
.measure ac Rin  PARAM='vino/iino'
.measure ac vlo FIND v(vout) AT=1Hz
.measure ac ilo FIND i(viout) AT=1Hz
.measure ac Rload  PARAM='vlo/ilo'
.measure ac Avo FIND v(vout) AT=1Hz
.measure ac Avio FIND v(vin) AT=1Hz
.measure ac Av  PARAM='Avo/Avio'
.ends CCnpn

.subckt CCpnp vin vout VEE VCC
+ R2=100k R1=10k RE=1k MM=1
Viin  vin  VB   DC    0V
R2    VCC  VB   R2
R1    VB   VEE  R1
XQ1   VCC  VB   VE    XPNPmodel M=MM
Viout vout VE   DC    0V
RE    VE   VEE  RE
.measure ac AvdB FIND par('vdb(vout)-vdb(vin)') AT=1Hz
.measure ac f3dB WHEN par('vdb(vout)-vdb(vin)')='AvdB-3' CROSS=1
.measure ac vino FIND v(vin) AT=1Hz
.measure ac iino FIND i(viin) AT=1Hz
.measure ac Rin  PARAM='vino/iino'
.measure ac vlo FIND v(vout) AT=1Hz
.measure ac ilo FIND i(viout) AT=1Hz
.measure ac Rload  PARAM='vlo/ilo'
.measure ac Avo FIND v(vout) AT=1Hz
.measure ac Avio FIND v(vin) AT=1Hz
.measure ac Av  PARAM='Avo/Avio'
.ends CCpnp

.subckt CCcmnpn vin vout VCC VEE
+ R=11.3k R2=20k R1=20k MM=1
Viin  vin  VB   DC    0V
R2    VCC  VB   R2
R1    VB   VEE  R1
XQ1   VCC  VB   VE    XNPNmodel M=MM
Viout vout VE   DC    0V
XQE   VE   vbias VEE  XNPNmodel M=MM
XQb   vbias vbias VEE XNPNmodel M=1
R     VCC vbias R
.measure ac AvdB FIND par('vdb(vout)-vdb(vin)') AT=1Hz
.measure ac f3dB WHEN par('vdb(vout)-vdb(vin)')='AvdB-3' CROSS=1
.measure ac vino FIND v(vin) AT=1Hz
.measure ac iino FIND i(viin) AT=1Hz
.measure ac Rin  PARAM='vino/iino'
.measure ac vlo FIND v(vout) AT=1Hz
.measure ac ilo FIND i(viout) AT=1Hz
.measure ac Rload  PARAM='vlo/ilo'
.measure ac Avo FIND v(vout) AT=1Hz
.measure ac Avio FIND v(vin) AT=1Hz
.measure ac Av  PARAM='Avo/Avio'
.ends CCcmnpn

.subckt CCcmpnp vin vout VEE VCC
+ R=11.3k R2=20k R1=20k MM=1
Viin  vin  VB   DC    0V
R2    VCC  VB   R2
R1    VB   VEE  R1
XQ1   VCC  VB   VE    XPNPmodel M=MM
Viout vout VE   DC    0V
XQE   VE   vbias VEE  XPNPmodel M=MM
XQb   vbias vbias VEE XPNPmodel M=1
R     VCC vbias R
.measure ac AvdB FIND par('vdb(vout)-vdb(vin)') AT=1Hz
.measure ac f3dB WHEN par('vdb(vout)-vdb(vin)')='AvdB-3' CROSS=1
.measure ac vino FIND v(vin) AT=1Hz
.measure ac iino FIND i(viin) AT=1Hz
.measure ac Rin  PARAM='vino/iino'
.measure ac vlo FIND v(vout) AT=1Hz
.measure ac ilo FIND i(viout) AT=1Hz
.measure ac Rload  PARAM='vlo/ilo'
.measure ac Avo FIND v(vout) AT=1Hz
.measure ac Avio FIND v(vin) AT=1Hz
.measure ac Av  PARAM='Avo/Avio'
.ends CCcmpnp

.subckt CSnmos vin vout VDD VSS
+ R2=4MEG R1=1MEG RS=100k RD=400k MM=1
Viin  vin  VG   DC    0V
R2    VDD  VG   R2
R1    VG   VSS  R1
XM1   VD   VG   VS    XNMOSmodel M=MM
RD    VDD  VD   RD
Viout vout VD   DC    0V
RS    VS   VSS  RS
CS    VS   VSS  10mF
.measure ac AvdB FIND par('vdb(vout)-vdb(vin)') AT=1Hz
.measure ac f3dB WHEN par('vdb(vout)-vdb(vin)')='AvdB-3' CROSS=1
.measure ac vino FIND v(vin) AT=1Hz
.measure ac iino FIND i(viin) AT=1Hz
.measure ac Rin  PARAM='vino/iino'
.measure ac vlo FIND v(vout) AT=1Hz
.measure ac ilo FIND i(viout) AT=1Hz
.measure ac Rload  PARAM='vlo/ilo'
.measure ac Avo FIND v(vout) AT=1Hz
.measure ac Avio FIND v(vin) AT=1Hz
.measure ac Av  PARAM='Avo/Avio'
.ends CSnmos

.subckt dCSnmos vin1 vin2 vout1 vout2 VDD VSS
+ R=1MEG R2=20MEG R1=20MEG RD=400k MM=1
Viin1 vin1 VG1  DC    0V
R21   VDD  VG1  R2
R11   VG1  VSS  R1
XM1   VD1  VG1  VS    XNMOSmodel M=MM
RD1   VDD  VD1  RD
Viout1 vout1 VD1  DC    0V
Viin2 vin2 VG2  DC    0V
R22   VDD  VG2  R2
R12   VG2  VSS  R1
XM2   VD2  VG2  VS    XNMOSmodel M=MM
RD2   VDD  VD2  RD
Viout2 vout2 VD2  DC    0V
XMS   VS   vbias VSS  XNMOSmodel M='2*MM'
XMb   vbias vbias VSS XNMOSmodel M=1
R     VDD vbias R
Evin  vin  0  vin1 vin2 1
Rvin vin 0 1T
Evout vout 0 vout1 vout2 1
Rvout vout 0 1T
.measure ac Av1dB FIND par('vdb(vout1)-vdb(vin)') AT=1Hz
.measure ac Av2dB FIND par('vdb(vout2)-vdb(vin)') AT=1Hz
.measure ac AvdB FIND par('vdb(vout)-vdb(vin)') AT=1Hz
.measure ac f3dB1 WHEN par('vdb(vout1)-vdb(vin)')='Av1dB-3' CROSS=1
.measure ac f3dB2  WHEN par('vdb(vout2)-vdb(vin)')='Av2dB-3' CROSS=1
.measure ac f3dB WHEN par('vdb(vout)-vdb(vin)')='AvdB-3' CROSS=1
.measure ac vin1o FIND v(vin1) AT=1Hz
.measure ac iin1o FIND i(viin1) AT=1Hz
.measure ac Rin1  PARAM='vin1o/iin1o'
.measure ac vl1o FIND v(vout1) AT=1Hz
.measure ac il1o FIND i(viout1) AT=1Hz
.measure ac Rload1  PARAM='vl1o/il1o'
.measure ac voo1 FIND v(vout1) AT=1Hz
.measure ac vio1 FIND v(vin1) AT=1Hz
.measure ac Av1  PARAM='voo1/vio1'
.measure ac vin2o FIND v(vin2) AT=1Hz
.measure ac iin2o FIND i(viin2) AT=1Hz
.measure ac Rin2  PARAM='vin2o/iin2o'
.measure ac vl2o FIND v(vout2) AT=1Hz
.measure ac il2o FIND i(viout2) AT=1Hz
.measure ac Rload2  PARAM='vl2o/il2o'
.measure ac voo2 FIND v(vout2) AT=1Hz
.measure ac vio2 FIND v(vin2) AT=1Hz
.measure ac Av2  PARAM='voo2/vio2'
.measure ac vin FIND v(vin) AT=1Hz
.measure ac iin FIND i(viin1) AT=1Hz
.measure ac Rin PARAM='vin/iin'
.measure ac vlo FIND v(vout) AT=1Hz
.measure ac ilo FIND i(viout1) AT=1Hz
.measure ac Rload PARAM='vlo/ilo'
.measure ac voo FIND v(vout) AT=1Hz
.measure ac vio FIND v(vin) AT=1Hz
.measure ac Avd1  PARAM='voo1/vio'
.measure ac Avd2  PARAM='voo2/vio'
.measure ac Av  PARAM='voo/vio'
.ends dCSnmos

.subckt CSwRSnmos vin vout VDD VSS
+ R2=4MEG R1=1MEG RS=100k RD=400k MM=1
Viin  vin  VG   DC    0V
R2    VDD  VG   R2
R1    VG   VSS  R1
XM1   VD   VG   VS    XNMOSmodel M=MM
RD    VDD  VD   RD
Viout vout VD   DC    0V
RS    VS   VSS  RS
.measure ac AvdB FIND par('vdb(vout)-vdb(vin)') AT=1Hz
.measure ac f3dB WHEN par('vdb(vout)-vdb(vin)')='AvdB-3' CROSS=1
.measure ac vino FIND v(vin) AT=1Hz
.measure ac iino FIND i(viin) AT=1Hz
.measure ac Rin  PARAM='vino/iino'
.measure ac vlo FIND v(vout) AT=1Hz
.measure ac ilo FIND i(viout) AT=1Hz
.measure ac Rload  PARAM='vlo/ilo'
.measure ac Avo FIND v(vout) AT=1Hz
.measure ac Avio FIND v(vin) AT=1Hz
.measure ac Av  PARAM='Avo/Avio'
.ends CSwRSnmos

.subckt dCSwRSNMOS vin1 vin2 vout1 vout2 VDD VSS
+ R=1MEG R2=20MEG R1=20MEG RD=400k RS=100k MM=1
Viin1 vin1 VG1  DC    0V
R21   VDD  VG1  R2
R11   VG1  VSS  R1
XM1   VD1  VG1  VS1   XNMOSmodel M=MM
RS1   VS1  VS   RS
RD1   VDD  VD1  RD
Viin2 vin2 VG2  DC    0V
R22   VDD  VG2  R2
R12   VG2  VSS  R1
XM2   VD2  VG2  VS2   XNMOSmodel M=MM
RS2   VS2  VS   RS
RD2   VDD  VD2  RD
Viout1 vout1 VD1   DC    0V
Viout2 vout2 VD2   DC    0V
XMD   VS   VGias VSS  XNMOSmodel M='2*MM'
XMG   VGias VGias VSS XNMOSmodel M=1
R     VDD VGias R
Evin  vin  0  vin1 vin2 1
Rvin vin 0 1T
Evout vout 0 vout1 vout2 1
Rvout vout 0 1T
.measure ac Av1dB FIND par('vdb(vout1)-vdb(vin)') AT=1Hz
.measure ac Av2dB FIND par('vdb(vout2)-vdb(vin)') AT=1Hz
.measure ac AvdB FIND par('vdb(vout)-vdb(vin)') AT=1Hz
.measure ac f3dB1 WHEN par('vdb(vout1)-vdb(vin)')='Av1dB-3' CROSS=1
.measure ac f3dB2  WHEN par('vdb(vout2)-vdb(vin)')='Av2dB-3' CROSS=1
.measure ac f3dB WHEN par('vdb(vout)-vdb(vin)')='AvdB-3' CROSS=1
.measure ac vin1o FIND v(vin1) AT=1Hz
.measure ac iin1o FIND i(viin1) AT=1Hz
.measure ac Rin1  PARAM='vin1o/iin1o'
.measure ac vl1o FIND v(vout1) AT=1Hz
.measure ac il1o FIND i(viout1) AT=1Hz
.measure ac Rload1  PARAM='vl1o/il1o'
.measure ac voo1 FIND v(vout1) AT=1Hz
.measure ac vio1 FIND v(vin1) AT=1Hz
.measure ac Av1  PARAM='voo1/vio1'
.measure ac vin2o FIND v(vin2) AT=1Hz
.measure ac iin2o FIND i(viin2) AT=1Hz
.measure ac Rin2  PARAM='vin2o/iin2o'
.measure ac vl2o FIND v(vout2) AT=1Hz
.measure ac il2o FIND i(viout2) AT=1Hz
.measure ac Rload2  PARAM='vl2o/il2o'
.measure ac voo2 FIND v(vout2) AT=1Hz
.measure ac vio2 FIND v(vin2) AT=1Hz
.measure ac Av2  PARAM='voo2/vio2'
.measure ac vin FIND v(vin) AT=1Hz
.measure ac iin FIND i(viin1) AT=1Hz
.measure ac Rin PARAM='vin/iin'
.measure ac vlo FIND v(vout) AT=1Hz
.measure ac ilo FIND i(viout1) AT=1Hz
.measure ac Rload PARAM='vlo/ilo'
.measure ac voo FIND v(vout) AT=1Hz
.measure ac vio FIND v(vin) AT=1Hz
.measure ac Avd1  PARAM='voo1/vio'
.measure ac Avd2  PARAM='voo2/vio'
.measure ac Av  PARAM='voo/vio'
.ends dCSwRSNMOS

.subckt CDnmos vin vout VDD VSS
+ R2=4MEG R1=1MEG RS=100k MM=1
Viin  vin  VG   DC    0V
R2    VDD  VG   R2
R1    VG   VSS  R1
XM1   VDD  VG   VS    XNMOSmodel M=MM
Viout vout VS   DC    0V
RS    VS   VSS  RS
.measure ac AvdB FIND par('vdb(vout)-vdb(vin)') AT=1Hz
.measure ac f3dB WHEN par('vdb(vout)-vdb(vin)')='AvdB-3' CROSS=1
.measure ac vino FIND v(vin) AT=1Hz
.measure ac iino FIND i(viin) AT=1Hz
.measure ac Rin  PARAM='vino/iino'
.measure ac vlo FIND v(vout) AT=1Hz
.measure ac ilo FIND i(viout) AT=1Hz
.measure ac Rload  PARAM='vlo/ilo'
.measure ac Avo FIND v(vout) AT=1Hz
.measure ac Avio FIND v(vin) AT=1Hz
.measure ac Av  PARAM='Avo/Avio'
.ends CDnmos

.subckt CDpmos vin vout VSS VDD
+ R2=4MEG R1=1MEG RS=100k MM=1
Viin  vin  VG   DC    0V
R2    VDD  VG   R2
R1    VG   VSS  R1
XM1   VDD  VG   VS    XPMOSmodel M=MM
Viout vout VS   DC    0V
RS    VS   VSS  RS
.measure ac AvdB FIND par('vdb(vout)-vdb(vin)') AT=1Hz
.measure ac f3dB WHEN par('vdb(vout)-vdb(vin)')='AvdB-3' CROSS=1
.measure ac vino FIND v(vin) AT=1Hz
.measure ac iino FIND i(viin) AT=1Hz
.measure ac Rin  PARAM='vino/iino'
.measure ac vlo FIND v(vout) AT=1Hz
.measure ac ilo FIND i(viout) AT=1Hz
.measure ac Rload  PARAM='vlo/ilo'
.measure ac Avo FIND v(vout) AT=1Hz
.measure ac Avio FIND v(vin) AT=1Hz
.measure ac Av  PARAM='Avo/Avio'
.ends CDpmos

.subckt CDcmnmos vin vout VDD VSS
+ R=1MEG R2=20MEG R1=20MEG MM=1
Viin  vin  VG   DC    0V
R2    VDD  VG   R2
R1    VG   VSS  R1
XM1   VDD  VG   VS    XNMOSmodel M=MM
Viout vout VS   DC    0V
XMS   VS   vbias VSS  XNMOSmodel M=MM
XMb   vbias vbias VSS XNMOSmodel M=1
R     VDD vbias R
.measure ac AvdB FIND par('vdb(vout)-vdb(vin)') AT=1Hz
.measure ac f3dB WHEN par('vdb(vout)-vdb(vin)')='AvdB-3' CROSS=1
.measure ac vino FIND v(vin) AT=1Hz
.measure ac iino FIND i(viin) AT=1Hz
.measure ac Rin  PARAM='vino/iino'
.measure ac vlo FIND v(vout) AT=1Hz
.measure ac ilo FIND i(viout) AT=1Hz
.measure ac Rload  PARAM='vlo/ilo'
.measure ac Avo FIND v(vout) AT=1Hz
.measure ac Avio FIND v(vin) AT=1Hz
.measure ac Av  PARAM='Avo/Avio'
.ends CDcmnmos

.subckt CDcmpmos vin vout VSS VDD
+ R=1MEG R2=20MEG R1=20MEG MM=1
Viin  vin  VG   DC    0V
R2    VDD  VG   R2
R1    VG   VSS  R1
XM1   VDD  VG   VS    XPMOSmodel M=MM
Viout vout VS   DC    0V
XMS   VS   vbias VSS  XNMOSmodel M=MM
XMb   vbias vbias VSS XNMOSmodel M=1
R     VDD vbias R
.measure ac AvdB FIND par('vdb(vout)-vdb(vin)') AT=1Hz
.measure ac f3dB WHEN par('vdb(vout)-vdb(vin)')='AvdB-3' CROSS=1
.measure ac vino FIND v(vin) AT=1Hz
.measure ac iino FIND i(viin) AT=1Hz
.measure ac Rin  PARAM='vino/iino'
.measure ac vlo FIND v(vout) AT=1Hz
.measure ac ilo FIND i(viout) AT=1Hz
.measure ac Rload  PARAM='vlo/ilo'
.measure ac Avo FIND v(vout) AT=1Hz
.measure ac Avio FIND v(vin) AT=1Hz
.measure ac Av  PARAM='Avo/Avio'
.ends CDcmpmos


*  worst case range of transistor model parameters DO NOT CHANGE

.DATA worstcase
BETA    VA      BETAMOS LAMBDA
100     100     225u    0.01
300     300     275u    0.003
.ENDDATA

* nominal values DO NOT CHANGE
.PARAM  BETA=200 VA=200 BETAMOS=250u LAMBDA=0.005

* BJT subcircuits and models DO NOT change

.model NPNmodel NPN IS=30F VAF=VA BF=BETA BR=1 IKF=1A RC=1 RB=10 RE=.01
+ CJC=.1p MJC=0 CJE=1p MJE=0 CJS=1p MJS=0 TF=10p
.subckt XNPNmodel VC VB VE M=1
Q VQC VQB VQE NPNmodel M
VIC VC VQC 0V
VIB VB VQB 0V
VIE VQE VE 0V
.ends XNPNmodel

.model PNPmodel PNP IS=30F VAF=VA BF=BETA BR=1 IKF=1A RC=1 RB=10 RE=.01
+ CJC=.1p MJC=0 CJE=1p MJE=0 CJS=1p MJS=0 TF=10p
.subckt XPNPmodel VC VB VE M=1
Q VQC VQB VQE PNPmodel M
VIC VQC VC 0V
VIB VQB VB 0V
VIE VE VQE 0V
.ends XPNPmodel

* MOSFET subcircuits and models DO NOT change

.model NMOSmodel NMOS LEVEL=1 KP='BETAMOS/2' VTO=1V Lambda=LAMBDA
+ RD=1 RS=0.01 
+ CBD=10f CBS=10f
.subckt XNMOSmodel VD VG VS M=1
M   VQD VQG VQS VQS NMOSmodel M=M
VID VD VQD 0V
VIG VG VQG 0V
VIS VQS VS 0V
.ends XNMOSmodel

.model PMOSmodel PMOS LEVEL=1 KP='BETAMOS/2' VTO=-1V Lambda=LAMBDA
+ RD=1 RS=0.01
+ CBD=10f CBS=10f
.subckt XPMOSmodel VD VG VS M=1
M   VQD VQG VQS VQS PMOSmodel M=M
VID VQD VD 0V
VIG VQG VG 0V
VIS VS VQS 0V
.ends XPMOSmodel

.END
.end

