EE3270 Hwk4 HSPICE file for multistage amp design

* bjt circuits

VCC      VCC         0          DC        12V
VACbjt   acbjt       0          AC        1mV     SIN(0mV 1mV 1kHz)
RSbjt    acbjt       inbjt      100k


XCC1a    inbjt       outcc1a    VCC       0      CCpnp
+        R2=1T       R1=1T      RE=10k    MM=1

CCC1b    outcc1a     incc1b     10mF
XCC1b    incc1b      outcc1b    VCC       0      CCpnp
+        R2=50k      R1=10k     RE=1k     MM=1

Cce1     outcc1b     ince1      10mF
XCE1     ince1       outce1     VCC       0      CEnpn
+        R2=50k      R1=10k     RE=1k     RC=1.8k  MM=1

XCC1c    outce1      outcc1c    VCC       0      CCpnp
+        R2=1T       R1=1T      RE=1k     MM=1

Ccewre1  outcc1c     incewre1   10mF
XCEwRE1  incewre1    outcewre1  VCC       0      CEwREnpn
+        R2=50k      R1=10k     RE=1k     RC=4k  MM=1

XCC1d    outcewre1   outcc1d    VCC       0      CCpnp
+        R2=1T       R1=1T      RE=1k     MM=1

CCEwRE2  outcc1d     incewre2   10mF
XCEwRE2  incewre2    outcewre2  VCC       0      CEwREnpn
+        R2=50k      R1=10k     RE=1k     RC=4k  MM=1

XCC2a    outcewre2   outcc2a    VCC       0      CCpnp
+        R2=1T       R1=1T      RE=1k     MM=1

CCC2     outcc2a     incc2      10mF
XCC2     incc2       outcc2     VCC       0      CCpnp
+        R2=20k      R1=20k     RE=1k     MM=1

CCC3     outcc2      incc3      10mF
XCC3     incc3       outcc3     VCC       0      CCnpn
+        R2='10k/25' R1='50k/25' RE='9k/25'      MM=25

Coutbjt  outcc3      outbjt     10mF
RLbjt    outbjt      0          50


* mos circuits

VDD      VDD         0          DC       12V
VACmos   acmos       0          AC       1mV      SIN(0mV 1mV 1kHz)
RSmos    acmos       inmos      100k

Ccs1     inmos       incs1      10mF
XCS1     incs1       outcs1     VDD      0       CSnmos
+        R2=40MEG    R1=10MEG   RS=100k  RD=800k MM=1

XCD1a    outcs1      outcd1a    VDD      0       CDpmos
+        R2=1T       R1=1T      RS=950k  MM=1

Ccswrs1  outcd1a     incswrs1   10mF
XCSwrs1  incswrs1    outcswrs1  VDD      0       CSwrsnmos
+        R2=40MEG    R1=10MEG   RS=100k  RD=500k MM=1

XCD1b    outcswrs1   outcd1b    VDD      0       CDpmos
+        R2=1T       R1=1T      RS=530k  MM=1

Ccswrs2  outcd1b     incswrs2   10mF
XCSwrs2  incswrs2    outcswrs2  VDD      0       CSwrsnmos
+        R2=40MEG    R1=10MEG   RS=100k  RD=360k MM=1

XCD1c    outcswrs2   outcd1c    VDD      0       CDpmos
+        R2=1T       R1=1T      RS=430k  MM=1

Ccd1     outcd1c     incd1      10mF
XCD1     incd1       outcd1     VDD      0       CDpmos
+        R2=20MEG    R1=20MEG   RS=580k  MM=1

Ccd2     outcd1      incd2      10mF
XCD2     incd2       outcd2     VDD      0       CDpmos
+        R2=20MEG    R1=20MEG   RS='580k/30'  MM=30

Ccd3     outcd2      incd3      10mF
XCD3     incd3       outcd3     VDD      0       CDpmos
+        R2=10MEG    R1=50MEG   RS='880k/6000'  MM=6000

Coutmos  outcd3      outmos     10mF
RLmos    outmos      0          50


* The analysis and output control section

* transient and fourier large signal analysis

* fourier analysis of outputs

.four 1kHz V(outbjt) V(outmos)
.four 1kHz v(outcd2) v(outcd1) v(outcd1c) v(outcswrs2)

* stage by stage outputs 

.options probe

.print tran v(acbjt) V(inbjt) v(outcc1a) v(outcc1b) v(outce1)
.print tran v(outcc1c) v(outcewre1) v(outcc1d) v(outcewre2) v(outcc2)
.print tran v(outcc3) V(outbjt) 
.print tran i(XCC2.XQ1.VIC) i(XCC3.XQ1.VIC) i(Coutbjt)
.print tran v(acmos) V(inmos) v(outcs1) v(outcd1a) v(outcswrs1)
.print tran v(outcd1b) v(outcswrs2) v(outcd1c) v(outcd1) 
.print tran v(outcd2) v(outcd3) V(outmos)
.print tran i(XCD2.XM1.VID) i(XCD3.XM1.VID) i(Coutmos)

* ac small signal analysis

.measure ac voo FIND v(outbjt) AT=1kHz
.measure ac vio FIND v(acbjt) AT=1kHz
.measure ac Av  PARAM='voo/vio'
.measure ac vom FIND v(outmos) AT=1kHz
.measure ac vim FIND v(acmos) AT=1kHz
.measure ac Avm  PARAM='vom/vim'
.measure ac vodb FIND vdb(outbjt) AT=1kHz
.measure ac f3dB WHEN vdb(outbjt)='vodb-3' CROSS=1
.measure ac vodbm FIND vdb(outmos) AT=1kHz
.measure ac f3dBm WHEN vdb(outmos)='vodbm-3' CROSS=1
.measure ac avrsdB FIND par('vdb(inbjt)-vdb(acbjt)') AT=1KHz
.measure ac f3dBrs WHEN par('vdb(inbjt)-vdb(acbjt)')='avrsdB-3' CROSS=1
.measure ac avrsdBm FIND par('vdb(inmos)-vdb(acmos)') AT=1KHz
.measure ac f3dBrsm WHEN par('vdb(inmos)-vdb(acmos)')='avrsdBm-3' CROSS=1

** Analysis setup **

.options post=2 measout badchr nopage co=160 opts cptime=1e7 limtim=60
+ defl=1.0um  defw=4.0um

.op
.tran 10us 5ms SWEEP DATA=worstcase
.ac DEC 30 1k 1000G SWEEP DATA=worstcase

* the subcircuits DO NOT Change

.subckt CEnpn vin vout VCC VEE
+ R2=100k R1=10k RE=1k RC=4k MM=1
Viin  vin  VB   DC    0V
R2    VCC  VB   R2
R1    VB   VEE  R1
XQ1   VC   VB   VE    XNPNmodel M=MM
RC    VCC  VC   RC
Viout vout VC   DC    0V
RE    VE   VEE  RE
CE    VE   VEE 10mF
.measure ac avodB FIND par('vdb(vout)-vdb(vin)') AT=1KHz
.measure ac f3dB WHEN par('vdb(vout)-vdb(vin)')='avodB-3' CROSS=1
.measure ac vino FIND v(vin) AT=1kHz
.measure ac iino FIND i(viin) AT=1kHz
.measure ac rino  PARAM='vino/iino'
.measure ac vlo FIND v(vout) AT=1kHz
.measure ac ilo FIND i(viout) AT=1kHz
.measure ac rloado  PARAM='vlo/ilo'
.measure ac Avoo FIND v(vout) AT=1kHz
.measure ac Avio FIND v(vin) AT=1kHz
.measure ac Avo  PARAM='Avoo/Avio'
.ends CEnpn

.subckt diffCEnpn vin1 vout1 vin2 vout2 VCC VEE
+ R=11.3k R2=20k R1=20k RC=4k MM=1
Viin1 vin1 VB1  DC    0V
R21   VCC  VB1  R2
R11   VB1  VEE  R1
XQ1   VC1  VB1  VE    XNPNmodel M=MM
RC1   VCC  VC1  RC
Viin2 vin2 VB2  DC    0V
R22   VCC  VB2  R2
R12   VB2  VEE  R1
XQ2   VC2  VB2  VE    XNPNmodel M=MM
RC2   VCC  VC2  RC
Viout1 vout1 VC1   DC    0V
Viout2 vout2 VC2   DC    0V
XQE   VE   vbias VEE  XNPNmodel M='2*MM'
XQb   vbias vbias VEE XNPNmodel M=MM
R     VCC vbias R
.measure ac avodB FIND par('vdb(vout)-vdb(vin)') AT=1KHz
.measure ac f3dB WHEN par('vdb(vout)-vdb(vin)')='avodB-3' CROSS=1
.measure ac vino FIND v(vin1) AT=1kHz
.measure ac iino FIND i(viin1) AT=1kHz
.measure ac rino  PARAM='vino/iino'
.measure ac vlo FIND v(vout1) AT=1kHz
.measure ac ilo FIND i(viout1) AT=1kHz
.measure ac rloado  PARAM='vlo/ilo'
.measure ac Avoo FIND v(vout1) AT=1kHz
.measure ac Avio FIND v(vin1) AT=1kHz
.measure ac Avo  PARAM='Avoo/Avio'
.ends diffCEnpn

.subckt CEwREnpn vin vout VCC VEE
+ R2=100k R1=10k RE=1k RC=4k MM=1
Viin  vin  VB   DC    0V
R2    VCC  VB   R2
R1    VB   VEE  R1
XQ1   VC   VB   VE    XNPNmodel M=MM
RC    VCC  VC   RC
Viout vout VC   DC    0V
RE    VE   VEE  RE
.measure ac avodB FIND par('vdb(vout)-vdb(vin)') AT=1KHz
.measure ac f3dB WHEN par('vdb(vout)-vdb(vin)')='avodB-3' CROSS=1
.measure ac vino FIND v(vin) AT=1kHz
.measure ac iino FIND i(viin) AT=1kHz
.measure ac rino  PARAM='vino/iino'
.measure ac vlo FIND v(vout) AT=1kHz
.measure ac ilo FIND i(viout) AT=1kHz
.measure ac rloado  PARAM='vlo/ilo'
.measure ac Avoo FIND v(vout) AT=1kHz
.measure ac Avio FIND v(vin) AT=1kHz
.measure ac Avo  PARAM='Avoo/Avio'
.ends CEwREnpn

.subckt diffCEwREnpn vin1 vout1 vin2 vout2 VCC VEE
+ R=11.3k R2=20k R1=20k RC=4k RE=1k MM=1
Viin1 vin1 VB1  DC    0V
R21   VCC  VB1  R2
R11   VB1  VEE  R1
XQ1   VC1  VB1  VE1   XNPNmodel M=MM
RE1   VE1  VE   RE
RC1   VCC  VC1  RC
Viin2 vin2 VB2  DC    0V
R22   VCC  VB2  R2
R12   VB2  VEE  R1
XQ2   VC2  VB2  VE2   XNPNmodel M=MM
RE2   VE2  VE   RE
RC2   VCC  VC2  RC
Viout1 vout1 VC1   DC    0V
Viout2 vout2 VC2   DC    0V
XQE   VE   vbias VEE  XNPNmodel M='2*MM'
XQb   vbias vbias VEE XNPNmodel M=MM
R     VCC vbias R
.measure ac avodB FIND par('vdb(vout)-vdb(vin)') AT=1KHz
.measure ac f3dB WHEN par('vdb(vout)-vdb(vin)')='avodB-3' CROSS=1
.measure ac vino FIND v(vin1) AT=1kHz
.measure ac iino FIND i(viin1) AT=1kHz
.measure ac rino  PARAM='vino/iino'
.measure ac vlo FIND v(vout1) AT=1kHz
.measure ac ilo FIND i(viout1) AT=1kHz
.measure ac rloado  PARAM='vlo/ilo'
.measure ac Avoo FIND v(vout1) AT=1kHz
.measure ac Avio FIND v(vin1) AT=1kHz
.measure ac Avo  PARAM='Avoo/Avio'
.ends diffCEwREnpn

.subckt CCnpn vin vout VCC VEE
+ R2=100k R1=10k RE=1k MM=1
Viin  vin  VB   DC    0V
R2    VCC  VB   R2
R1    VB   VEE  R1
XQ1   VCC  VB   VE    XNPNmodel M=MM
Viout vout VE   DC    0V
RE    VE   VEE  RE
.measure ac avodB FIND par('vdb(vout)-vdb(vin)') AT=1KHz
.measure ac f3dB WHEN par('vdb(vout)-vdb(vin)')='avodB-3' CROSS=1
.measure ac vino FIND v(vin) AT=1kHz
.measure ac iino FIND i(viin) AT=1kHz
.measure ac rino  PARAM='vino/iino'
.measure ac vlo FIND v(vout) AT=1kHz
.measure ac ilo FIND i(viout) AT=1kHz
.measure ac rloado  PARAM='vlo/ilo'
.measure ac Avoo FIND v(vout) AT=1kHz
.measure ac Avio FIND v(vin) AT=1kHz
.measure ac Avo  PARAM='Avoo/Avio'
.ends CCnpn

.subckt CCpnp vin vout VEE VCC
+ R2=100k R1=10k RE=1k MM=1
Viin  vin  VB   DC    0V
R2    VCC  VB   R2
R1    VB   VEE  R1
XQ1   VCC  VB   VE    XPNPmodel M=MM
Viout vout VE   DC    0V
RE    VE   VEE  RE
.measure ac avodB FIND par('vdb(vout)-vdb(vin)') AT=1KHz
.measure ac f3dB WHEN par('vdb(vout)-vdb(vin)')='avodB-3' CROSS=1
.measure ac vino FIND v(vin) AT=1kHz
.measure ac iino FIND i(viin) AT=1kHz
.measure ac rino  PARAM='vino/iino'
.measure ac vlo FIND v(vout) AT=1kHz
.measure ac ilo FIND i(viout) AT=1kHz
.measure ac rloado  PARAM='vlo/ilo'
.measure ac Avoo FIND v(vout) AT=1kHz
.measure ac Avio FIND v(vin) AT=1kHz
.measure ac Avo  PARAM='Avoo/Avio'
.ends CCpnp

.subckt CCcmnpn vin vout VCC VEE
+ R=11.3k R2=20k R1=20k MM=1
Viin  vin  VB   DC    0V
R2    VCC  VB   R2
R1    VB   VEE  R1
XQ1   VCC  VB   VE    XNPNmodel M=MM
Viout vout VE   DC    0V
XQE   VE   vbias VEE  XNPNmodel M=MM
XQb   vbias vbias VEE XNPNmodel M=MM
R     VCC vbias R
.measure ac avodB FIND par('vdb(vout)-vdb(vin)') AT=1KHz
.measure ac f3dB WHEN par('vdb(vout)-vdb(vin)')='avodB-3' CROSS=1
.measure ac vino FIND v(vin) AT=1kHz
.measure ac iino FIND i(viin) AT=1kHz
.measure ac rino  PARAM='vino/iino'
.measure ac vlo FIND v(vout) AT=1kHz
.measure ac ilo FIND i(viout) AT=1kHz
.measure ac rloado  PARAM='vlo/ilo'
.measure ac Avoo FIND v(vout) AT=1kHz
.measure ac Avio FIND v(vin) AT=1kHz
.measure ac Avo  PARAM='Avoo/Avio'
.ends CCcmnpn

.subckt CCcmpnp vin vout VEE VCC
+ R=11.3k R2=20k R1=20k MM=1
Viin  vin  VB   DC    0V
R2    VCC  VB   R2
R1    VB   VEE  R1
XQ1   VCC  VB   VE    XPNPmodel M=MM
Viout vout VE   DC    0V
XQE   VE   vbias VEE  XPNPmodel M=MM
XQb   vbias vbias VEE XPNPmodel M=MM
R     VCC vbias R
.measure ac avodB FIND par('vdb(vout)-vdb(vin)') AT=1KHz
.measure ac f3dB WHEN par('vdb(vout)-vdb(vin)')='avodB-3' CROSS=1
.measure ac vino FIND v(vin) AT=1kHz
.measure ac iino FIND i(viin) AT=1kHz
.measure ac rino  PARAM='vino/iino'
.measure ac vlo FIND v(vout) AT=1kHz
.measure ac ilo FIND i(viout) AT=1kHz
.measure ac rloado  PARAM='vlo/ilo'
.measure ac Avoo FIND v(vout) AT=1kHz
.measure ac Avio FIND v(vin) AT=1kHz
.measure ac Avo  PARAM='Avoo/Avio'
.ends CCcmpnp

.subckt CSnmos vin vout VDD VSS
+ R2=4MEG R1=1MEG RS=100k RD=400k MM=1
Viin  vin  VG   DC    0V
R2    VDD  VG   R2
R1    VG   VSS  R1
XM1   VD   VG   VS    XNMOSmodel M=MM
RD    VDD  VD   RD
Viout vout VD   DC    0V
RS    VS   VSS  RS
CS    VS   VSS  10mF
.measure ac avodB FIND par('vdb(vout)-vdb(vin)') AT=1KHz
.measure ac f3dB WHEN par('vdb(vout)-vdb(vin)')='avodB-3' CROSS=1
.measure ac vino FIND v(vin) AT=1kHz
.measure ac iino FIND i(viin) AT=1kHz
.measure ac rino  PARAM='vino/iino'
.measure ac vlo FIND v(vout) AT=1kHz
.measure ac ilo FIND i(viout) AT=1kHz
.measure ac rloado  PARAM='vlo/ilo'
.measure ac Avoo FIND v(vout) AT=1kHz
.measure ac Avio FIND v(vin) AT=1kHz
.measure ac Avo  PARAM='Avoo/Avio'
.ends CSnmos

.subckt diffCSnmos vin1 vout1 vin2 vout2 VDD VSS
+ R=1MEG R2=20MEG R1=20MEG RD=400k MM=1
Viin1 vin1 VG1  DC    0V
R21   VDD  VG1  R2
R11   VG1  VSS  R1
XM1   VD1  VG1  VS    XNMOSmodel M=MM
RD1   VDD  VD1  RD
Viout1 vout1 VD1  DC    0V
Viin2 vin2 VG2  DC    0V
R22   VDD  VG2  R2
R12   VG2  VSS  R1
XM2   VD2  VG2  VS    XNMOSmodel M=MM
RD2   VDD  VD2  RD
Viout2 vout2 VD2  DC    0V
XMS   VS   vbias VSS  XNMOSmodel M='2*MM'
XMb   vbias vbias VSS XNMOSmodel M=MM
R     VDD vbias R
.measure ac avodB FIND par('vdb(vout)-vdb(vin)') AT=1KHz
.measure ac f3dB WHEN par('vdb(vout)-vdb(vin)')='avodB-3' CROSS=1
.measure ac vino FIND v(vin1) AT=1kHz
.measure ac iino FIND i(viin1) AT=1kHz
.measure ac rino  PARAM='vino/iino'
.measure ac vlo FIND v(vout1) AT=1kHz
.measure ac ilo FIND i(viout1) AT=1kHz
.measure ac rloado  PARAM='vlo/ilo'
.measure ac Avoo FIND v(vout1) AT=1kHz
.measure ac Avio FIND v(vin1) AT=1kHz
.measure ac Avo  PARAM='Avoo/Avio'
.ends diffCSnmos

.subckt CSwRSnmos vin vout VDD VSS
+ R2=4MEG R1=1MEG RS=100k RD=400k MM=1
Viin  vin  VG   DC    0V
R2    VDD  VG   R2
R1    VG   VSS  R1
XM1   VD   VG   VS    XNMOSmodel M=MM
RD    VDD  VD   RD
Viout vout VD   DC    0V
RS    VS   VSS  RS
.measure ac avodB FIND par('vdb(vout)-vdb(vin)') AT=1KHz
.measure ac f3dB WHEN par('vdb(vout)-vdb(vin)')='avodB-3' CROSS=1
.measure ac vino FIND v(vin) AT=1kHz
.measure ac iino FIND i(viin) AT=1kHz
.measure ac rino  PARAM='vino/iino'
.measure ac vlo FIND v(vout) AT=1kHz
.measure ac ilo FIND i(viout) AT=1kHz
.measure ac rloado  PARAM='vlo/ilo'
.measure ac Avoo FIND v(vout) AT=1kHz
.measure ac Avio FIND v(vin) AT=1kHz
.measure ac Avo  PARAM='Avoo/Avio'
.ends CSwRSnmos

.subckt diffCSwRSNMOS vin1 vout1 vin2 vout2 VDD VSS
+ R=1MEG R2=20MEG R1=20MEG RD=400k RS=100k MM=1
Viin1 vin1 VG1  DC    0V
R21   VDD  VG1  R2
R11   VG1  VSS  R1
XM1   VD1  VG1  VS1   XNMOSmodel M=MM
RS1   VS1  VS   RS
RD1   VDD  VD1  RD
Viin2 vin2 VG2  DC    0V
R22   VDD  VG2  R2
R12   VG2  VSS  R1
XM2   VD2  VG2  VS2   XNMOSmodel M=MM
RS2   VS2  VS   RS
RD2   VDD  VD2  RD
Viout1 vout1 VD1   DC    0V
Viout2 vout2 VD2   DC    0V
XMD   VS   VGias VSS  XNMOSmodel M='2*MM'
XMG   VGias VGias VSS XNMOSmodel M=MM
R     VDD VGias R
.measure ac avodB FIND par('vdb(vout)-vdb(vin)') AT=1KHz
.measure ac f3dB WHEN par('vdb(vout)-vdb(vin)')='avodB-3' CROSS=1
.measure ac vino FIND v(vin1) AT=1kHz
.measure ac iino FIND i(viin1) AT=1kHz
.measure ac rino  PARAM='vino/iino'
.measure ac vlo FIND v(vout1) AT=1kHz
.measure ac ilo FIND i(viout1) AT=1kHz
.measure ac rloado  PARAM='vlo/ilo'
.measure ac Avoo FIND v(vout1) AT=1kHz
.measure ac Avio FIND v(vin1) AT=1kHz
.measure ac Avo  PARAM='Avoo/Avio'
.ends diffCSwRSNMOS

.subckt CDnmos vin vout VDD VSS
+ R2=4MEG R1=1MEG RS=100k MM=1
Viin  vin  VG   DC    0V
R2    VDD  VG   R2
R1    VG   VSS  R1
XM1   VDD  VG   VS    XNMOSmodel M=MM
Viout vout VS   DC    0V
RS    VS   VSS  RS
.measure ac avodB FIND par('vdb(vout)-vdb(vin)') AT=1KHz
.measure ac f3dB WHEN par('vdb(vout)-vdb(vin)')='avodB-3' CROSS=1
.measure ac vino FIND v(vin) AT=1kHz
.measure ac iino FIND i(viin) AT=1kHz
.measure ac rino  PARAM='vino/iino'
.measure ac vlo FIND v(vout) AT=1kHz
.measure ac ilo FIND i(viout) AT=1kHz
.measure ac rloado  PARAM='vlo/ilo'
.measure ac Avoo FIND v(vout) AT=1kHz
.measure ac Avio FIND v(vin) AT=1kHz
.measure ac Avo  PARAM='Avoo/Avio'
.ends CDnmos

.subckt CDpmos vin vout VSS VDD
+ R2=4MEG R1=1MEG RS=100k MM=1
Viin  vin  VG   DC    0V
R2    VDD  VG   R2
R1    VG   VSS  R1
XM1   VDD  VG   VS    XPMOSmodel M=MM
Viout vout VS   DC    0V
RS    VS   VSS  RS
.measure ac avodB FIND par('vdb(vout)-vdb(vin)') AT=1KHz
.measure ac f3dB WHEN par('vdb(vout)-vdb(vin)')='avodB-3' CROSS=1
.measure ac vino FIND v(vin) AT=1kHz
.measure ac iino FIND i(viin) AT=1kHz
.measure ac rino  PARAM='vino/iino'
.measure ac vlo FIND v(vout) AT=1kHz
.measure ac ilo FIND i(viout) AT=1kHz
.measure ac rloado  PARAM='vlo/ilo'
.measure ac Avoo FIND v(vout) AT=1kHz
.measure ac Avio FIND v(vin) AT=1kHz
.measure ac Avo  PARAM='Avoo/Avio'
.ends CDpmos

.subckt CDcmnmos vin vout VDD VSS
+ R=1MEG R2=20MEG R1=20MEG MM=1
Viin  vin  VG   DC    0V
R2    VDD  VG   R2
R1    VG   VSS  R1
XM1   VDD  VG   VS    XNMOSmodel M=MM
Viout vout VS   DC    0V
XMS   VS   vbias VSS  XNMOSmodel M=MM
XMb   vbias vbias VSS XNMOSmodel M=MM
R     VDD vbias R
.measure ac avodB FIND par('vdb(vout)-vdb(vin)') AT=1KHz
.measure ac f3dB WHEN par('vdb(vout)-vdb(vin)')='avodB-3' CROSS=1
.measure ac vino FIND v(vin) AT=1kHz
.measure ac iino FIND i(viin) AT=1kHz
.measure ac rino  PARAM='vino/iino'
.measure ac vlo FIND v(vout) AT=1kHz
.measure ac ilo FIND i(viout) AT=1kHz
.measure ac rloado  PARAM='vlo/ilo'
.measure ac Avoo FIND v(vout) AT=1kHz
.measure ac Avio FIND v(vin) AT=1kHz
.measure ac Avo  PARAM='Avoo/Avio'
.ends CDcmnmos

.subckt CDcmpmos vin vout VSS VDD
+ R=1MEG R2=20MEG R1=20MEG MM=1
Viin  vin  VG   DC    0V
R2    VDD  VG   R2
R1    VG   VSS  R1
XM1   VDD  VG   VS    XPMOSmodel M=MM
Viout vout VS   DC    0V
XMS   VS   vbias VSS  XNMOSmodel M=MM
XMb   vbias vbias VSS XNMOSmodel M=MM
R     VDD vbias R
.measure ac avodB FIND par('vdb(vout)-vdb(vin)') AT=1KHz
.measure ac f3dB WHEN par('vdb(vout)-vdb(vin)')='avodB-3' CROSS=1
.measure ac vino FIND v(vin) AT=1kHz
.measure ac iino FIND i(viin) AT=1kHz
.measure ac rino  PARAM='vino/iino'
.measure ac vlo FIND v(vout) AT=1kHz
.measure ac ilo FIND i(viout) AT=1kHz
.measure ac rloado  PARAM='vlo/ilo'
.measure ac Avoo FIND v(vout) AT=1kHz
.measure ac Avio FIND v(vin) AT=1kHz
.measure ac Avo  PARAM='Avoo/Avio'
.ends CDcmpmos


*  worst case range of values DO NOT CHANGE

.DATA worstcase
BETA    VA      BETAMOS LAMBDA
100     100     250u    0.01
300     300     275u    0.003
.ENDDATA

* nominal values DO NOT CHANGE
.PARAM  BETA=100 VA=100 BETAMOS=250u LAMBDA=0.01

* BJT model parameters

.model NPNmodel NPN IS=30F VAF=VA BF=BETA BR=1 IKF=1A RC=1 RB=10 RE=.01
+ CJC=.1p MJC=0 CJE=1p MJE=0 CJS=1p MJS=0 TF=10p
.subckt XNPNmodel VC VB VE M=1
Q VQC VQB VQE NPNmodel M
VIC VC VQC 0V
VIB VB VQB 0V
VIE VQE VE 0V
.ends XNPNmodel

.model PNPmodel PNP IS=30F VAF=VA BF=BETA BR=1 IKF=1A RC=1 RB=10 RE=.01
+ CJC=.1p MJC=0 CJE=1p MJE=0 CJS=1p MJS=0 TF=10p
.subckt XPNPmodel VC VB VE M=1
Q VQC VQB VQE PNPmodel M
VIC VQC VC 0V
VIB VQB VB 0V
VIE VE VQE 0V
.ends XPNPmodel

* MOSFET model parameters

.model NMOSmodel NMOS LEVEL=1 KP='BETAMOS/2' VTO=1V Lambda=LAMBDA
+ RD=1 RS=0.01 
+ CBD=10f CBS=10f
.subckt XNMOSmodel VD VG VS M=1
M   VQD VQG VQS VQS NMOSmodel M=M
VID VD VQD 0V
VIG VG VQG 0V
VIS VQS VS 0V
.ends XNMOSmodel

.model PMOSmodel PMOS LEVEL=1 KP='BETAMOS/2' VTO=-1V Lambda=LAMBDA
+ RD=1 RS=0.01
+ CBD=10f CBS=10f
.subckt XPMOSmodel VD VG VS M=1
M   VQD VQG VQS VQS PMOSmodel M=M
VID VQD VD 0V
VIG VQG VG 0V
VIS VS VQS 0V
.ends XPMOSmodel

.END
.end
